from fred_api.registry.contact import contact_common_types_pb2 as _contact_common_types_pb2
from fred_api.registry import common_types_pb2 as _common_types_pb2
from fred_api.registry import object_events_pb2 as _object_events_pb2
from fred_api.registry.registrar import registrar_common_types_pb2 as _registrar_common_types_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf.internal import enum_type_wrapper as _enum_type_wrapper
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class ContactInfoRequest(_message.Message):
    __slots__ = ("contact_id", "contact_history_id")
    CONTACT_ID_FIELD_NUMBER: _ClassVar[int]
    CONTACT_HISTORY_ID_FIELD_NUMBER: _ClassVar[int]
    contact_id: _contact_common_types_pb2.ContactId
    contact_history_id: _contact_common_types_pb2.ContactHistoryId
    def __init__(self, contact_id: _Optional[_Union[_contact_common_types_pb2.ContactId, _Mapping]] = ..., contact_history_id: _Optional[_Union[_contact_common_types_pb2.ContactHistoryId, _Mapping]] = ...) -> None: ...

class NationalIdentityNumber(_message.Message):
    __slots__ = ("value",)
    VALUE_FIELD_NUMBER: _ClassVar[int]
    value: str
    def __init__(self, value: _Optional[str] = ...) -> None: ...

class NationalIdentityCard(_message.Message):
    __slots__ = ("value",)
    VALUE_FIELD_NUMBER: _ClassVar[int]
    value: str
    def __init__(self, value: _Optional[str] = ...) -> None: ...

class PassportNumber(_message.Message):
    __slots__ = ("value",)
    VALUE_FIELD_NUMBER: _ClassVar[int]
    value: str
    def __init__(self, value: _Optional[str] = ...) -> None: ...

class SocialSecurityNumber(_message.Message):
    __slots__ = ("value",)
    VALUE_FIELD_NUMBER: _ClassVar[int]
    value: str
    def __init__(self, value: _Optional[str] = ...) -> None: ...

class Birthdate(_message.Message):
    __slots__ = ("value",)
    VALUE_FIELD_NUMBER: _ClassVar[int]
    value: str
    def __init__(self, value: _Optional[str] = ...) -> None: ...

class ContactAdditionalIdentifier(_message.Message):
    __slots__ = ("national_identity_number", "national_identity_card", "passport_number", "company_registration_number", "social_security_number", "birthdate")
    NATIONAL_IDENTITY_NUMBER_FIELD_NUMBER: _ClassVar[int]
    NATIONAL_IDENTITY_CARD_FIELD_NUMBER: _ClassVar[int]
    PASSPORT_NUMBER_FIELD_NUMBER: _ClassVar[int]
    COMPANY_REGISTRATION_NUMBER_FIELD_NUMBER: _ClassVar[int]
    SOCIAL_SECURITY_NUMBER_FIELD_NUMBER: _ClassVar[int]
    BIRTHDATE_FIELD_NUMBER: _ClassVar[int]
    national_identity_number: NationalIdentityNumber
    national_identity_card: NationalIdentityCard
    passport_number: PassportNumber
    company_registration_number: _common_types_pb2.CompanyRegistrationNumber
    social_security_number: SocialSecurityNumber
    birthdate: Birthdate
    def __init__(self, national_identity_number: _Optional[_Union[NationalIdentityNumber, _Mapping]] = ..., national_identity_card: _Optional[_Union[NationalIdentityCard, _Mapping]] = ..., passport_number: _Optional[_Union[PassportNumber, _Mapping]] = ..., company_registration_number: _Optional[_Union[_common_types_pb2.CompanyRegistrationNumber, _Mapping]] = ..., social_security_number: _Optional[_Union[SocialSecurityNumber, _Mapping]] = ..., birthdate: _Optional[_Union[Birthdate, _Mapping]] = ...) -> None: ...

class ContactAddress(_message.Message):
    __slots__ = ("company", "street", "city", "state_or_province", "postal_code", "country_code")
    COMPANY_FIELD_NUMBER: _ClassVar[int]
    STREET_FIELD_NUMBER: _ClassVar[int]
    CITY_FIELD_NUMBER: _ClassVar[int]
    STATE_OR_PROVINCE_FIELD_NUMBER: _ClassVar[int]
    POSTAL_CODE_FIELD_NUMBER: _ClassVar[int]
    COUNTRY_CODE_FIELD_NUMBER: _ClassVar[int]
    company: str
    street: _containers.RepeatedScalarFieldContainer[str]
    city: str
    state_or_province: str
    postal_code: _common_types_pb2.PostalCode
    country_code: _common_types_pb2.CountryCode
    def __init__(self, company: _Optional[str] = ..., street: _Optional[_Iterable[str]] = ..., city: _Optional[str] = ..., state_or_province: _Optional[str] = ..., postal_code: _Optional[_Union[_common_types_pb2.PostalCode, _Mapping]] = ..., country_code: _Optional[_Union[_common_types_pb2.CountryCode, _Mapping]] = ...) -> None: ...

class WarningLetter(_message.Message):
    __slots__ = ("preference",)
    class SendingPreference(_message.Message):
        __slots__ = ()
        class Enum(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
            __slots__ = ()
            to_send: _ClassVar[WarningLetter.SendingPreference.Enum]
            not_to_send: _ClassVar[WarningLetter.SendingPreference.Enum]
            not_specified: _ClassVar[WarningLetter.SendingPreference.Enum]
        to_send: WarningLetter.SendingPreference.Enum
        not_to_send: WarningLetter.SendingPreference.Enum
        not_specified: WarningLetter.SendingPreference.Enum
        def __init__(self) -> None: ...
    PREFERENCE_FIELD_NUMBER: _ClassVar[int]
    preference: WarningLetter.SendingPreference.Enum
    def __init__(self, preference: _Optional[_Union[WarningLetter.SendingPreference.Enum, str]] = ...) -> None: ...

class ContactInfoReply(_message.Message):
    __slots__ = ("data", "exception")
    class Data(_message.Message):
        __slots__ = ("contact_handle", "contact_id", "contact_history_id", "name", "organization", "place", "telephone", "fax", "emails", "notify_emails", "vat_identification_number", "additional_identifier", "publish", "mailing_address", "billing_address", "shipping_address1", "shipping_address2", "shipping_address3", "warning_letter", "auth_info", "events", "sponsoring_registrar")
        class PublishEntry(_message.Message):
            __slots__ = ("key", "value")
            KEY_FIELD_NUMBER: _ClassVar[int]
            VALUE_FIELD_NUMBER: _ClassVar[int]
            key: str
            value: bool
            def __init__(self, key: _Optional[str] = ..., value: bool = ...) -> None: ...
        CONTACT_HANDLE_FIELD_NUMBER: _ClassVar[int]
        CONTACT_ID_FIELD_NUMBER: _ClassVar[int]
        CONTACT_HISTORY_ID_FIELD_NUMBER: _ClassVar[int]
        NAME_FIELD_NUMBER: _ClassVar[int]
        ORGANIZATION_FIELD_NUMBER: _ClassVar[int]
        PLACE_FIELD_NUMBER: _ClassVar[int]
        TELEPHONE_FIELD_NUMBER: _ClassVar[int]
        FAX_FIELD_NUMBER: _ClassVar[int]
        EMAILS_FIELD_NUMBER: _ClassVar[int]
        NOTIFY_EMAILS_FIELD_NUMBER: _ClassVar[int]
        VAT_IDENTIFICATION_NUMBER_FIELD_NUMBER: _ClassVar[int]
        ADDITIONAL_IDENTIFIER_FIELD_NUMBER: _ClassVar[int]
        PUBLISH_FIELD_NUMBER: _ClassVar[int]
        MAILING_ADDRESS_FIELD_NUMBER: _ClassVar[int]
        BILLING_ADDRESS_FIELD_NUMBER: _ClassVar[int]
        SHIPPING_ADDRESS1_FIELD_NUMBER: _ClassVar[int]
        SHIPPING_ADDRESS2_FIELD_NUMBER: _ClassVar[int]
        SHIPPING_ADDRESS3_FIELD_NUMBER: _ClassVar[int]
        WARNING_LETTER_FIELD_NUMBER: _ClassVar[int]
        AUTH_INFO_FIELD_NUMBER: _ClassVar[int]
        EVENTS_FIELD_NUMBER: _ClassVar[int]
        SPONSORING_REGISTRAR_FIELD_NUMBER: _ClassVar[int]
        contact_handle: _contact_common_types_pb2.ContactHandle
        contact_id: _contact_common_types_pb2.ContactId
        contact_history_id: _contact_common_types_pb2.ContactHistoryId
        name: str
        organization: str
        place: _common_types_pb2.PlaceAddress
        telephone: _common_types_pb2.PhoneNumber
        fax: _common_types_pb2.PhoneNumber
        emails: _containers.RepeatedCompositeFieldContainer[_common_types_pb2.EmailAddress]
        notify_emails: _containers.RepeatedCompositeFieldContainer[_common_types_pb2.EmailAddress]
        vat_identification_number: _common_types_pb2.VatIdentificationNumber
        additional_identifier: ContactAdditionalIdentifier
        publish: _containers.ScalarMap[str, bool]
        mailing_address: ContactAddress
        billing_address: ContactAddress
        shipping_address1: ContactAddress
        shipping_address2: ContactAddress
        shipping_address3: ContactAddress
        warning_letter: WarningLetter
        auth_info: _common_types_pb2.AuthInfo
        events: _object_events_pb2.ObjectEvents
        sponsoring_registrar: _registrar_common_types_pb2.RegistrarHandle
        def __init__(self, contact_handle: _Optional[_Union[_contact_common_types_pb2.ContactHandle, _Mapping]] = ..., contact_id: _Optional[_Union[_contact_common_types_pb2.ContactId, _Mapping]] = ..., contact_history_id: _Optional[_Union[_contact_common_types_pb2.ContactHistoryId, _Mapping]] = ..., name: _Optional[str] = ..., organization: _Optional[str] = ..., place: _Optional[_Union[_common_types_pb2.PlaceAddress, _Mapping]] = ..., telephone: _Optional[_Union[_common_types_pb2.PhoneNumber, _Mapping]] = ..., fax: _Optional[_Union[_common_types_pb2.PhoneNumber, _Mapping]] = ..., emails: _Optional[_Iterable[_Union[_common_types_pb2.EmailAddress, _Mapping]]] = ..., notify_emails: _Optional[_Iterable[_Union[_common_types_pb2.EmailAddress, _Mapping]]] = ..., vat_identification_number: _Optional[_Union[_common_types_pb2.VatIdentificationNumber, _Mapping]] = ..., additional_identifier: _Optional[_Union[ContactAdditionalIdentifier, _Mapping]] = ..., publish: _Optional[_Mapping[str, bool]] = ..., mailing_address: _Optional[_Union[ContactAddress, _Mapping]] = ..., billing_address: _Optional[_Union[ContactAddress, _Mapping]] = ..., shipping_address1: _Optional[_Union[ContactAddress, _Mapping]] = ..., shipping_address2: _Optional[_Union[ContactAddress, _Mapping]] = ..., shipping_address3: _Optional[_Union[ContactAddress, _Mapping]] = ..., warning_letter: _Optional[_Union[WarningLetter, _Mapping]] = ..., auth_info: _Optional[_Union[_common_types_pb2.AuthInfo, _Mapping]] = ..., events: _Optional[_Union[_object_events_pb2.ObjectEvents, _Mapping]] = ..., sponsoring_registrar: _Optional[_Union[_registrar_common_types_pb2.RegistrarHandle, _Mapping]] = ...) -> None: ...
    class Exception(_message.Message):
        __slots__ = ("contact_does_not_exist",)
        class ContactDoesNotExist(_message.Message):
            __slots__ = ()
            def __init__(self) -> None: ...
        CONTACT_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
        contact_does_not_exist: ContactInfoReply.Exception.ContactDoesNotExist
        def __init__(self, contact_does_not_exist: _Optional[_Union[ContactInfoReply.Exception.ContactDoesNotExist, _Mapping]] = ...) -> None: ...
    DATA_FIELD_NUMBER: _ClassVar[int]
    EXCEPTION_FIELD_NUMBER: _ClassVar[int]
    data: ContactInfoReply.Data
    exception: ContactInfoReply.Exception
    def __init__(self, data: _Optional[_Union[ContactInfoReply.Data, _Mapping]] = ..., exception: _Optional[_Union[ContactInfoReply.Exception, _Mapping]] = ...) -> None: ...

class ContactIdRequest(_message.Message):
    __slots__ = ("contact_handle",)
    CONTACT_HANDLE_FIELD_NUMBER: _ClassVar[int]
    contact_handle: _contact_common_types_pb2.ContactHandle
    def __init__(self, contact_handle: _Optional[_Union[_contact_common_types_pb2.ContactHandle, _Mapping]] = ...) -> None: ...

class ContactIdReply(_message.Message):
    __slots__ = ("data", "exception")
    class Data(_message.Message):
        __slots__ = ("contact_id", "contact_history_id")
        CONTACT_ID_FIELD_NUMBER: _ClassVar[int]
        CONTACT_HISTORY_ID_FIELD_NUMBER: _ClassVar[int]
        contact_id: _contact_common_types_pb2.ContactId
        contact_history_id: _contact_common_types_pb2.ContactHistoryId
        def __init__(self, contact_id: _Optional[_Union[_contact_common_types_pb2.ContactId, _Mapping]] = ..., contact_history_id: _Optional[_Union[_contact_common_types_pb2.ContactHistoryId, _Mapping]] = ...) -> None: ...
    class Exception(_message.Message):
        __slots__ = ("contact_does_not_exist",)
        class ContactDoesNotExist(_message.Message):
            __slots__ = ()
            def __init__(self) -> None: ...
        CONTACT_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
        contact_does_not_exist: ContactIdReply.Exception.ContactDoesNotExist
        def __init__(self, contact_does_not_exist: _Optional[_Union[ContactIdReply.Exception.ContactDoesNotExist, _Mapping]] = ...) -> None: ...
    DATA_FIELD_NUMBER: _ClassVar[int]
    EXCEPTION_FIELD_NUMBER: _ClassVar[int]
    data: ContactIdReply.Data
    exception: ContactIdReply.Exception
    def __init__(self, data: _Optional[_Union[ContactIdReply.Data, _Mapping]] = ..., exception: _Optional[_Union[ContactIdReply.Exception, _Mapping]] = ...) -> None: ...
